package com.cool.store.mapper;

import com.cool.store.entity.EnterpriseUserDO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author zhangchenbiao
 * @date 2023-06-06 02:29
 */
public interface EnterpriseUserMapper {
    /**
     *
     * 默认插入方法，只会给有值的字段赋值
     * 会对传进来的字段做判空处理，如果字段为空，则使用数据库默认字段或者null
     * dateTime:2023-06-06 02:29
     */
    int batchInsertOrUpdate(@Param("recordList") List<EnterpriseUserDO> recordList);

    /**
     *
     * 默认更新方法，根据主键更新，不会把null值更新到数据库，避免覆盖之前有值的
     * dateTime:2023-06-06 02:29
     */
    int updateByPrimaryKeySelective(EnterpriseUserDO record);

    /**
     * 获取用户信息
     * @param userId
     * @return
     */
    EnterpriseUserDO getUserInfoById(@Param("userId") String userId);

    /**
     * 批量获取用户信息
     * @param userIdList
     * @return
     */
    List<EnterpriseUserDO> getUserInfoByUserIds(@Param("userIdList") List<String> userIdList);

    /**
     * 删除用户
     * @param excludeUserIds
     * @return
     */
    int deleteUser(@Param("excludeUserIds") List<String> excludeUserIds);

    /**
     * 删除用户
     * @param userId
     * @return
     */
    Integer deleteUserByUserId(@Param("userId") String userId);

    /**
     * 根据关键字搜索部门下的用户
     * @param regionIds
     * @param keyword
     * @param leaderRegionIds
     * @return
     */
    List<EnterpriseUserDO> searchUserByRegionIdsAndKeyword(@Param("regionIds") List<String> regionIds, @Param("keyword") String keyword, @Param("leaderRegionIds") List<String> leaderRegionIds);

    /**
     * 获取部门用户数
     * @param regionId
     * @return
     */
    Integer getUserCountByRegionId(@Param("regionId") String regionId);


    /**
     * 获取部门负责人用户列表
     * @param regionId
     * @return
     */
    List<EnterpriseUserDO> getUserListByDeptLeader(String regionId);

    /**
     * 根据开发经理获取用户列表
     * @param regionIds
     * @return
     */
    List<EnterpriseUserDO> getUserListByDeptLeaders(@Param("regionIds") List<String> regionIds);

    /**
     * 获取部门人员
     * @param regionIds
     * @return
     */
    List<EnterpriseUserDO> getUserListByRegionIds(@Param("regionIds") List<String> regionIds);

    String selectByMobile(@Param("mobile") String mobile);

}